/*********************************************************
/
   1. Use EnumProcesses    CX DWORD PID
   2. Use OpenProcess N PID -> HANDLE hProcess
   3. Use EnumProcessModules , GetModuleBaseName CX ModuleBaseName
   4. Use VMQuery CX HANDLE hProcess Ҧ memory block
   5. Use ReadProcessMemory Nw memory block Ū
/
*********************************************************/
// test_mem.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

void PrintModulesInfo( DWORD processID )
{
    HANDLE hProcess;

    // Print the process identifier.

    printf( "Process ID: %u\n", processID );

    // Print information about the memory usage of the process.

    hProcess = OpenProcess(  PROCESS_QUERY_INFORMATION |
                                    PROCESS_VM_READ,
                                    FALSE, processID );

   DWORD lpcbNeeded;
   if( EnumProcessModules( hProcess , NULL, 0, &lpcbNeeded) )
   {
     HMODULE *hModule = (HMODULE *)new char[lpcbNeeded];
     if( EnumProcessModules( hProcess , hModule, lpcbNeeded, &lpcbNeeded) )
     {
        char name[512];
        GetModuleFileNameEx(hProcess, *hModule, name, 512);
        printf( "Module FileName: %s\n", name );
        GetModuleBaseName(hProcess, *hModule, name, 512);
        printf( "Module BaseName : %s\n", name );
     }
     delete hModule;
   }

   CloseHandle( hProcess );

   printf("\n");

}

void PrintMemoryInfo( DWORD processID )
{
    HANDLE hProcess;
    PROCESS_MEMORY_COUNTERS pmc;

    // Print the process identifier.

    printf( "\nProcess ID: %u\n", processID );

    // Print information about the memory usage of the process.

    hProcess = OpenProcess(  PROCESS_QUERY_INFORMATION |
                                    PROCESS_VM_READ,
                                    FALSE, processID );

    if ( GetProcessMemoryInfo( hProcess, &pmc, sizeof(pmc)) )
    {
        printf( "\tPageFaultCount: 0x%08X\n", pmc.PageFaultCount );
        printf( "\tPeakWorkingSetSize: 0x%08X\n",
                  pmc.PeakWorkingSetSize );
        printf( "\tWorkingSetSize: 0x%08X\n", pmc.WorkingSetSize );
        printf( "\tQuotaPeakPagedPoolUsage: 0x%08X\n",
                  pmc.QuotaPeakPagedPoolUsage );
        printf( "\tQuotaPagedPoolUsage: 0x%08X\n",
                  pmc.QuotaPagedPoolUsage );
        printf( "\tQuotaPeakNonPagedPoolUsage: 0x%08X\n",
                  pmc.QuotaPeakNonPagedPoolUsage );
        printf( "\tQuotaNonPagedPoolUsage: 0x%08X\n",
                  pmc.QuotaNonPagedPoolUsage );
        printf( "\tPagefileUsage: 0x%08X\n", pmc.PagefileUsage );
        printf( "\tPeakPagefileUsage: 0x%08X\n",
                  pmc.PeakPagefileUsage );
    }

    CloseHandle( hProcess );
}

/*********************************************************
/
/
/
*********************************************************/

void doit(HANDLE hProcess)
{

    BOOL fOk = TRUE;
    PVOID pvAddress = NULL;
    int addr;

    addr = 0xc000;


    while (fOk)
     {
        VMQUERY vmq;
        fOk = VMQuery(hProcess, pvAddress, &vmq);

         if(1) //(vmq.BlkSize == 0x801000)
         {
            BYTE buff[1000];
            //SIZE_T lpNumberOfBytesRead;
            //ReadProcessMemory( (void*)&dwProcessId, vmq.pvBlkBaseAddress, (void*)buff, 100, &lpNumberOfBytesRead);

            DWORD dummy;

            addr += (int)vmq.pvBlkBaseAddress;

            if (! ReadProcessMemory( hProcess, (void*) addr, (void*) &buff, 8, &dummy) )
            {
              //cout << "failed to read process" << endl;
            }

            printf("Address %08x = %02x %02x %02x %02x %02x %02x %02x %02x\n",addr, buff[0],buff[1],buff[2],buff[3],buff[4],buff[5],buff[6],buff[7]);

            //break;
         }

         // Get the address of the next region to test.
         pvAddress = ((PBYTE) vmq.pvRgnBaseAddress + vmq.RgnSize);
     }
}

/*********************************************************
/
/
/
*********************************************************/


void GetTHIS( DWORD processID )
{
    HANDLE hProcess;


    // Print information about the memory usage of the process.

    hProcess = OpenProcess(  PROCESS_QUERY_INFORMATION |
                                    PROCESS_VM_READ,
                                    FALSE, processID );

   DWORD lpcbNeeded;
   if( EnumProcessModules( hProcess , NULL, 0, &lpcbNeeded) )
   {
     HMODULE *hModule = (HMODULE *)new char[lpcbNeeded];
     if( EnumProcessModules( hProcess , hModule, lpcbNeeded, &lpcbNeeded) )
     {
        char name[512];
        GetModuleBaseName(hProcess, *hModule, name, 512);
        if( strcmp( name, "svchost.exe" ) == 0 )
        {
           printf("Dump svchost.exe\n");
           doit(hProcess);
        }
     }
     delete hModule;
   }

   CloseHandle( hProcess );

}

/*********************************************************
/
/
/
*********************************************************/

void main( )
{
    // Get the list of process identifiers.

    DWORD aProcesses[1024], cbNeeded, cProcesses;
    unsigned int i;

    if ( !EnumProcesses( aProcesses, sizeof(aProcesses), &cbNeeded ) )
        return;

    // Calculate how many process identifiers were returned.

    cProcesses = cbNeeded / sizeof(DWORD);

    // Print the memory usage for each process

    for ( i = 0; i < cProcesses; i++ )
        PrintMemoryInfo( aProcesses[i] );

    for ( i = 0; i < cProcesses; i++ )
        PrintModulesInfo( aProcesses[i] );

    for ( i = 0; i < cProcesses; i++ )
    {
      GetTHIS( aProcesses[i] );
    }

}
